
set server TIASQl
/

remark
\
,       " ."
/


connect PEAK9999 sysadm/sysadm
/

remark
\
,    -  ,    ""   
   ...
/


CREATE TABLE SYSADM.ListDBase (
  ID VARCHAR(18) NOT NULL, 
  NAME VARCHAR(32) NOT NULL, 
  DBNAME VARCHAR(8) NOT NULL, 
  PARENS VARCHAR(18), 
  DBPREFF VARCHAR(2), 
  ABOUT LONG VARCHAR
)
/
CREATE INDEX SYSADM.DEFINIT_DBNAME ON SYSADM.ListDBase (
  DBNAME)
/
CREATE INDEX SYSADM.DEFINIT_DBPREFF ON SYSADM.ListDBase (
  DBPREFF)
/
CREATE UNIQUE INDEX SYSADM.DEFINIT_ID ON SYSADM.ListDBase (
  ID)
/
CREATE INDEX SYSADM.DEFINIT_NAME ON SYSADM.ListDBase (
  NAME)
/
CREATE INDEX SYSADM.DEFINIT_PARENS ON SYSADM.ListDBase (
  PARENS)
/
ALTER TABLE SYSADM.ListDBase PRIMARY KEY (
  ID)
/
GRANT SELECT ON SYSADM.ListDBase TO PUBLIC 
/



CREATE TABLE SYSADM.LISTGROUP (
  ID VARCHAR(18) NOT NULL, 
  NAME VARCHAR(64) NOT NULL, 
  ABOUT  VARCHAR(254)
)
/
CREATE UNIQUE INDEX SYSADM.LIGR002 ON SYSADM.LISTGROUP(
  NAME)
/
CREATE UNIQUE INDEX SYSADM.UNIGROUP001 ON SYSADM.LISTGROUP(
  ID)
/
ALTER TABLE SYSADM.LISTGROUP PRIMARY KEY (
  ID)
/
CREATE PUBLIC SYNONYM LISTGROUP FOR SYSADM.LISTGROUP
/

CREATE TABLE SYSADM.LISTUSER (
  ID VARCHAR(18) NOT NULL, 
  Permit_LEVEL CHAR(1), 
  NAME VARCHAR(64) NOT NULL, 
  WRKPASS VARCHAR(254), 
  ABOUT VARCHAR(254), 
  ID_DB_LOCATE VARCHAR(18))
/
CREATE UNIQUE INDEX SYSADM.IND_99993_1 ON SYSADM.LISTUSER(
  ID)
/
CREATE INDEX SYSADM.IND_99993_3 ON SYSADM.LISTUSER(
  NAME)
/
GRANT SELECT ON SYSADM.LISTUSER TO PUBLIC 
/
ALTER TABLE SYSADM.LISTUSER PRIMARY KEY (
  ID)
/
ALTER TABLE SYSADM.LISTUSER FOREIGN KEY LUser001 (
  ID_DB_LOCATE) REFERENCES SYSADM.ListDBase 
/ 
CREATE PUBLIC SYNONYM LISTUSER FOR SYSADM.LISTUSER
/

CREATE TABLE SYSADM.CROSSUSGROUP (
  IDUSER VARCHAR(18) NOT NULL, 
  IDGROUP VARCHAR(18) NOT NULL)
/
CREATE UNIQUE INDEX SYSADM.CROSS002 ON SYSADM.CROSSUSGROUP(
  IDGROUP, 
  IDUSER)
/
CREATE INDEX SYSADM.IND_VSYJHB_1 ON SYSADM.CROSSUSGROUP(
  IDUSER)
/
CREATE INDEX SYSADM.IND_VSYJHB_2 ON SYSADM.CROSSUSGROUP(
  IDGROUP)
/

ALTER TABLE SYSADM.CROSSUSGROUP FOREIGN KEY CrossUs001 (
  IDUSER ) REFERENCES SYSADM.LISTUSER 
/ 
ALTER TABLE SYSADM.CROSSUSGROUP FOREIGN KEY CrossUs002 (
  IDGROUP ) REFERENCES SYSADM.LISTGROUP 
/ 

CREATE TABLE SYSADM.LISTRIGTHUS (
  IDUSER VARCHAR(18), 
  IDGROUP VARCHAR(18), 
  IDDOC VARCHAR(18), 
  IDTABLE VARCHAR(18), 
  RIGTH DOUBLE PRECISION NOT NULL, 
  IDSUBC VARCHAR(18))
/
CREATE INDEX SYSADM.IND_99976_1 ON SYSADM.LISTRIGTHUS(
  IDUSER)
/
CREATE INDEX SYSADM.IND_99976_2 ON SYSADM.LISTRIGTHUS(
  IDDOC)
/
CREATE INDEX SYSADM.IND_99976_3 ON SYSADM.LISTRIGTHUS(
  IDTABLE)
/
CREATE INDEX SYSADM.IND_99976_4 ON SYSADM.LISTRIGTHUS(
  IDSUBC)
/
CREATE UNIQUE INDEX SYSADM.LIR20021601 ON SYSADM.LISTRIGTHUS(
  IDUSER, 
  IDGROUP, 
  IDDOC, 
  IDTABLE, 
  RIGTH, 
  IDSUBC)
PCTFREE 10
/

ALTER TABLE SYSADM.LISTRIGTHUS FOREIGN KEY RIGTHUS001 (
  IDUSER ) REFERENCES SYSADM.LISTUSER 
/ 
ALTER TABLE SYSADM.LISTRIGTHUS FOREIGN KEY RIGTHUS002 (
  IDGROUP ) REFERENCES SYSADM.LISTGROUP 
/ 

CREATE PUBLIC SYNONYM LISTRIGTHUS FOR SYSADM.LISTRIGTHUS
/


STORE SYSADM.SETGRUS Procedure:  SetGrUs
	Parameters
		String: strUserName
		String: strUserPassv
		String: strLocAutori
	Local variables
		String: strCommand
		String: strUserAutoriLevel
	Actions
		On Procedure Execute
			Set strCommand = ' grant connect to ' || strUserName
			Set strCommand = strCommand || ' identified by ' || strUserPassv
			Call SqlImmediate ( strCommand )
!     ,      .
			Set strCommand = ' grant execute on SYSADM.GetUsersID to ' || strUserName
			Call SqlImmediate ( strCommand )
			Set strCommand = ' grant execute on SYSADM.GETMAXID to ' || strUserName
			Call SqlImmediate ( strCommand )
!    -   ,    .
			If strLocAutori = 'R'
				Set strCommand = ' grant resource to ' || strUserName
				Call SqlImmediate ( strCommand )
			If strLocAutori = 'D'
				Set strUserAutoriLevel  = 'dba'
				Set strCommand = ' grant dba to ' || strUserName
				Call SqlImmediate ( strCommand )
/


STORE SYSADM.GETLIRIGALL select  c.name, b.TabName, 
@if (sum(@mod( @int( Rigth/1000 ), 10 )), 1, 0) AS Sel, 
@If (sum(@mod( @int( Rigth/100 ), 10 )), 1, 0)  AS Ins, 
@If (sum(@mod( @int( Rigth/10 ), 10 )), 1, 0) AS Upd,  
@If (sum(@mod( @int( Rigth/1 ), 10 )), 1, 0)  AS Del, 
@if ( @length( DELETEAUTH || INSERTAUTH || SELECTAUTH || UPDATEAUTH), 1, 0 ) 
 from ListRigthUs a, LPatTables b, LISTUSER c, ListDBase d, SYSTABAUTH 
where 
a.IDTABLE = b.ID 
and a.IDUSER  = c.ID 
and c.ID =  :1  
and c.ID_DB_LOCATE = d.ID 
and @scan (DBNAME, @upper ( :2 ) ) = 0 
and GRANTEE (+) = @upper ( c.name ) 
and TTNAME (+) = @upper ( b.TabName ) 
group by 1, 2,  7 
union 
select  c.name, b.TabName, 
@if (sum(@mod( @int( Rigth/1000 ), 10 )), 1, 0), 
@If (sum(@mod( @int( Rigth/100 ), 10 )), 1, 0), 
@If (sum(@mod( @int( Rigth/10 ), 10 )), 1, 0),  
@If (sum(@mod( @int( Rigth/1 ), 10 )), 1, 0),  
@if ( @length( DELETEAUTH || INSERTAUTH || SELECTAUTH || UPDATEAUTH), 1, 0 ) 
 from ListRigthUs a, LPatTables b, LISTUSER c, CrossUsGroup d, ListDBase e, SYSTABAUTH 
where 
a.IDTABLE = b.ID 
and a.IDGROUP = d.IDGroup 
and c.ID = d.IDUser 
and a.IDTABLE not in  (select IDTABLE from ListRigthUs where IDUSER = d.IDUser ) 
and c.ID =  :1  
and c.ID_DB_LOCATE = e.ID 
and @scan (DBNAME, @upper ( :2 ) ) = 0 
and GRANTEE (+) = @upper ( c.name ) 
and TTNAME (+) = @upper ( b.TabName ) 
group by 1,2,  7 
union 
select  c.name, b.TabName, 0, 0, 0, 0, 
@if ( @length( DELETEAUTH || INSERTAUTH || SELECTAUTH || UPDATEAUTH), 1, 0 ) 
 from LPatTables b, LISTUSER c, CrossUsGroup d, ListDBase  e, SYSTABAUTH 
where 
c.ID = d.IDUser 
and c.ID =  :1  
and c.ID_DB_LOCATE = e.ID 
and @scan (DBNAME, @upper ( :2 ) ) = 0 
and GRANTEE  = @upper ( c.name ) 
and TTNAME  = @upper ( b.TabName ) 
and c.ID not in ( select a.IDUSER from  ListRigthUs a where a.IDTABLE = b.ID ) 
and c.ID not in ( select d.IDUSER from  ListRigthUs a, CrossUsGroup d   
		where a.IDTABLE = b.ID  and a.IDGROUP = d.IDGroup ) 
union 
select	c.name, b.TabName, 
@if (sum(@mod( @int( Rigth/1000 ), 10 )), 1, 0), 
@If (sum(@mod( @int( Rigth/100 ), 10 )), 1, 0), 
@If (sum(@mod( @int( Rigth/10 ), 10 )), 1, 0), 
@If (sum(@mod( @int( Rigth/1 ), 10 )), 1, 0), 
0 
 from ListRigthUs a, LPatTables b, LISTUSER c, ListDBase  e 
where 
a.IDTABLE = b.ID 
and ( a.IDUser = c.ID or a.IDGroup in (select  q.IDGroup from CrossUsGroup q where q.IDUser = c.ID)) 
and  c.ID =  :1  
and c.ID_DB_LOCATE = e.ID 
and @upper (DBNAME ) =  @upper ( :2 )  
group by 1, 2
/


STORE SYSADM.REVUSTABLERIGTH Procedure:  RevUsTablRigth
	Parameters
		String: strUserName
		String: strTableName

	Local variables
		String: Grant1
	Actions
		On Procedure Execute
			Set Grant1 = ' revoke all on ' || strTableName || ' from ' || strUserName
			Call SqlImmediate (  Grant1 )
/


STORE SYSADM.SETUSTABLERIGTH Procedure:  SetUsTableRigth
	Parameters
		String: strUserName
		String: strTableName
		Number: nSel
		Number: nIns
		Number: nUpd
		Number: nDel
	Local variables
		String: Grant3
		String: Grant2
		Sql Handle: hsqlWWW
		Number: nOk
	Actions
		On Procedure Execute
			Set Grant2 = ''
			If nSel = 1
				If Grant2 != ''
					Set Grant2 = Grant2 || ', '
				Set Grant2 = Grant2 || 'select'
			If nIns = 1
				If Grant2 != ''
					Set Grant2 = Grant2 || ', '
				Set Grant2 = Grant2 || 'insert'
			If nUpd = 1
				If Grant2 != ''
					Set Grant2 = Grant2 || ', '
				Set Grant2 = Grant2 || 'update'
			If nDel = 1
				If Grant2 != ''
					Set Grant2 = Grant2 || ', '
				Set Grant2 = Grant2 || 'delete'
			If Grant2 != ''
				Set Grant3 = ' grant ' || Grant2 || ' on ' || strTableName
				Set Grant3 = Grant3 || ' to ' || strUserName
				Call SqlImmediate (  Grant3 )

/


STORE SYSADM.SETUSERTRIGTH Procedure:  SetUserTRigth static
	Parameters
		String:  strIDUser
	Local variables
		Sql Handle: hsqlWWW
		Sql Handle: hsqlW01
		Number: nOk
		Number: numIi
		Number: nCount
		Number: nIsSet
		String: strBaseName
		String: strLocNameUser
		String: strTableName
		Boolean: bIsOk
		Number: nSel
		Number: nIns
		Number: nUpd
		Number: nDel
	Actions
		On Procedure Startup
			Call SqlConnect ( hsqlWWW )
			Call SqlConnect ( hsqlW01 )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( hsqlWWW )
				Set nOk = SqlError ( hsqlW01 )
				Return FALSE
			Set nCount = 0
!  " "
			Call SqlGetParameterAll ( hsqlWWW, 2001, nOk, strBaseName, bIsOk )
!     ,      ,   ,    ...
			Call SqlRetrieve ( hsqlWWW, 'SYSADM.GetLiRigAll', ' :strIDUser,  :strBaseName   ', ' :strLocNameUser, :strTableName, :nSel, :nIns, :nUpd, :nDel, :nIsSet  ' )
			Call SqlExecute( hsqlWWW )
			Call SqlGetResultSetCount ( hsqlWWW, nCount )
			Set numIi = 0
			Set nIsSet  = 0
			If ( nCount > 0 )
				Loop
					Call SqlFetchNext  ( hsqlWWW,  nOk )
					If (nOk != FETCH_Ok ) OR (numIi > 1000 )
						Break
					Set numIi = numIi +1
!      ,   , ,   "" ,    ... ,  ,  
					If nIsSet  = 1
						Call SqlRetrieve ( hsqlW01, 'SYSADM.RevUsTableRigth', ' :strLocNameUser, :strTableName ', '' )
						Call SqlExecute ( hsqlW01 )
! ,     "",    ...
					If ( nSel + nIns + nUpd + nDel > 0 )
						Call SqlRetrieve ( hsqlW01, 'SYSADM.SetUsTableRigth', ' :strLocNameUser, :strTableName, :nSel, :nIns, :nUpd, :nDel ', '')
						Call SqlExecute ( hsqlW01 )

		On Procedure Close
			Call SqlDisconnect ( hsqlWWW )
			Call SqlDisconnect ( hsqlW01 )
/


STORE SYSADM.GETCURBASEID select b.ID, a.ID 
from ListDBase b, listuser a 
where  
 @upper ( b.DBNAME ) = @upper  ( :1 ) 
and @upper ( a.Name ) = @upper ( :2 ) 
/


STORE SYSADM.INSUS220402 Procedure:  InsUs220402 static
	Parameters
		String:  strNameUser
		String:  strPassUser
		String:  strBaseID
		String:  strIDUser
		String: strLocAutoriLevel
	Local variables
		Sql Handle: hsqlWWW
		Number: nOk
		String: strBaseName
		String: strIDLocBase
		String: strIDName
		Boolean: bIsOk
	Actions
		On Procedure Startup
  			Call SqlConnect ( hsqlWWW )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( hsqlWWW )
				Return FALSE
!     .
			Call SqlGetParameterAll ( hsqlWWW, 2001, nOk, strBaseName, bIsOk )
! ,     ""   ...         .
			Call SqlRetrieve ( hsqlWWW, 'SYSADM.GetCurBaseID', ' :strBaseName, :strNameUser ', ' :strIDLocBase, :strIDName ' )
			Call SqlExecute( hsqlWWW )
			Call SqlFetchNext  ( hsqlWWW,  nOk )
			If strIDLocBase  = strBaseID
!   ,      ,  ,      ,   ...   ...
				Call SqlRetrieve ( hsqlWWW, 'SYSADM.SetGrUs', ' :strNameUser, :strPassUser,  :strLocAutoriLevel ', '')
				Call SqlExecute ( hsqlWWW )
!          .
				Call SqlRetrieve ( hsqlWWW, 'SYSADM.SetUserTRigth', ' :strIDUser ', '')
				Call SqlExecute ( hsqlWWW )
	On Procedure Close
		Call SqlDisconnect ( hsqlWWW )
/


CREATE TRIGGER SYSADM.INS_USLI220401 After Insert
ON SYSADM.LISTUSER
 ( Execute SYSADM.InsUs220402 ( 
LISTUSER.Name, LISTUSER.WrkPass, LISTUSER.ID_DB_LOCATE, LISTUSER.ID, LISTUSER.Permit_LEVEL ) )
For Each Row
/


STORE SYSADM.GETUSRIGTH220403 select  RESOURCEAUTH, DBAAUTH , 'C' 
from SYSUSERAUTH  
where  
 @upper ( name )  = @upper ( :1 ) 
/

STORE SYSADM.LISRREALRIGTH 
select TTNAME from SYSTABAUTH 
where  
 @upper ( GRANTEE ) = @upper  ( :1 )  
/

STORE SYSADM.USREVGRANTS Procedure:  UsRevGrants
	Parameters
		String: strUserName
	Local variables
		String: strCSelect
		String: strSelWhere
		String: strSelInto
		Number: nOk
		Number: numIi
		String: strLockTabName
		Number: nCount
		String: Grant1
		String: Grant2
		String: Grant3
		Sql Handle: SqlW
		Number: NotCreate
		String: SetStatus

	Actions
		On Procedure Startup
			When SqlError
				Set nOk = SqlError ( SqlW )
				Return FALSE
			Call SqlConnect ( SqlW )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( SqlW )
				Return FALSE
!   ,      .
			Call SqlRetrieve ( SqlW, 'sysadm.LisrRealRigth', ' :strUserName ', ' :strLockTabName ' )
			Call SqlExecute( SqlW )
			Call SqlGetResultSetCount ( SqlW, nCount )
			Set numIi = 0
			Set Grant1 = ' revoke all on '
			Set Grant2 = ''
			If nCount > 0
				Set Grant2 = ''
				Loop
!   ,     ...
					Call SqlFetchNext ( SqlW, nOk )
					If (nOk != FETCH_Ok ) OR (numIi > 1000 )
						Break
					Set numIi = numIi +1
!  ,   ,  ...
					If Grant2 != ''
						Set Grant2 = Grant2 || ', '
					Set Grant2 = Grant2 || strLockTabName
				If Grant2 != ''
					Set Grant3 = Grant1 || Grant2
					Set Grant3 = Grant3 || ' from ' || strUserName
					Call SqlImmediate (  Grant3 )
		On Procedure Close
			Call SqlDisconnect ( SqlW )
/


STORE SYSADM.REVGRUS Procedure:  RevGrUs
	Parameters
		String: strUserName
		String: strFlag
	Local variables
		Number: nOk
		Number: numIi
		String: strLockTabName
		String: strCommand
		Sql Handle: SqlW
	Actions
		On Procedure Startup
			Call SqlConnect ( SqlW )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( SqlW )
				Return FALSE
			Call SqlRetrieve ( SqlW, 'sysadm.UsRevGrants',  ' :strUserName ', '' )
			Call SqlExecute( SqlW )
			If strFlag = 'D'
				Set strCommand = ' revoke DBA from ' || strUserName
				Call SqlImmediate ( strCommand )
			If strFlag = 'R'
				Set strCommand = ' revoke resource from ' || strUserName
				Call SqlImmediate ( strCommand )
			Set strCommand = ' revoke connect from ' || strUserName
			Call SqlImmediate ( strCommand )
/

STORE SYSADM.CHANGEGRUS Procedure:  ChangeGrUs
	Parameters
		String: strUserName
		String: strOldFlag
		String: strNewFlag
	Local variables
		String: strCommand
	Actions
		On Procedure Execute
!  ... ...
			If strOldFlag = 'D'
				Set strCommand = ' revoke DBA from ' || strUserName
				Call SqlImmediate ( strCommand )

			If strOldFlag = 'R'
				Set strCommand = ' revoke resource from ' || strUserName
				Call SqlImmediate ( strCommand )
!  ...
			If strNewFlag = 'R'
				Set strCommand = ' grant resource to ' || strUserName
				Call SqlImmediate ( strCommand )
			If strNewFlag = 'D'
				Set strCommand = ' grant dba to ' || strUserName
				Call SqlImmediate ( strCommand )
/


STORE SYSADM.UPDUS220402 Procedure:  UpdUs220402 static
	Parameters
		String: strNameUser
		String: strOldPass
		String: strNewPass
		String: strOldBaseID
		String: strNewBaseID
		String: strOldAutoriLevel
		String: strNewAutoriLevel
	Local variables
		String: strCommand
		String: strWhere
		String: strInto
		Sql Handle: hsqlWWW
		Number: nOk
		Number: nCount
		String: strBaseName
		String: strIDLocBase
		String: strRESOURCE
		String: strDBA
		String: strUserAutoriLevel
		String: strIDUsss
		Boolean: bIsOk
	Actions
		On Procedure Startup
			Call SqlConnect ( hsqlWWW )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( hsqlWWW )
				Return FALSE
!        
			Call SqlGetParameterAll ( hsqlWWW, 2001, nOk, strBaseName, bIsOk )
			Call SqlRetrieve ( hsqlWWW, 'GetCurBaseID', ' :strBaseName, :strNameUser  ', ' :strIDLocBase, :strIDUsss ' )
			Call SqlExecute( hsqlWWW )
			Call SqlFetchNext  ( hsqlWWW,  nOk )
!       ""...
			Call SqlRetrieve ( hsqlWWW, 'sysadm.GetUsRigth220403', ' :strNameUser ',  ' :strRESOURCE, :strDBA, :strUserAutoriLevel   ' )
			Call SqlExecute( hsqlWWW )
			Call SqlGetResultSetCount ( hsqlWWW, nCount )
!     ,    ...
			If ( nCount = 0 )
				If ( ( strOldBaseID != strIDLocBase ) and  ( strNewBaseID = strIDLocBase ) )
					Call SqlRetrieve(hsqlWWW,  'SYSADM.SetGrUs', ' :strNameUser, :strNewPass,  :strNewAutoriLevel  ', '')
					Call SqlExecute ( hsqlWWW )
					Call SqlRetrieve ( hsqlWWW, 'SYSADM.SetUserTRigth', ' :strIDUsss ', '')
					Call SqlExecute ( hsqlWWW )
			If ( nCount > 0 )
!				If strOldPass !=  strNewPass
!					Set strCommand = ' alter password ' || strNameUser
!					Call SqlImmediate ( strCommand )
				If ( ( strOldBaseID = strIDLocBase ) and  ( strNewBaseID != strIDLocBase ) )
					Call SqlRetrieve(hsqlWWW, 'SYSADM.RevGrUs',  ' :strNameUser, :strOldAutoriLevel  ', '')
					Call SqlExecute ( hsqlWWW )
				If ( strOldAutoriLevel  !=  strNewAutoriLevel ) and ( strOldBaseID = strNewBaseID )
					Call SqlRetrieve(hsqlWWW, 'SYSADM.ChangeGrUs', ' :strNameUser, :strOldAutoriLevel,  :strNewAutoriLevel ', '')
					Call SqlExecute ( hsqlWWW )

		On Procedure Close
			Call SqlDisconnect ( hsqlWWW )
/


CREATE TRIGGER SYSADM.UPD_USLI220401 After Update
ON SYSADM.LISTUSER REFERENCING OLD oldTAble  NEW NewTAble
 ( Execute sysadm.UpdUs220402 ( 
NewTAble.Name, oldTAble.WrkPass, NewTAble.WrkPass, 
oldTAble.ID_DB_LOCATE, NewTAble.ID_DB_LOCATE, oldTAble.Permit_LEVEL, NewTAble.Permit_LEVEL ))
 For Each Row
/



STORE SYSADM.DELUS220402 Procedure:  DelUs220402 static
	Parameters
		String: strNameUser
		String: strLocAutoriLevel
	Local variables
		Boolean: bIsOk
		Number: nOk
		Number: nCount
		Sql Handle: hsqlWWW
		String: strBaseName
		String: strRESOURCE
		String: strDBA
		String: strUserAutoriLevel
	Actions
		On Procedure Startup
			Call SqlConnect ( hsqlWWW )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( hsqlWWW )
				Return FALSE
			Call SqlGetParameterAll ( hsqlWWW, 2001, nOk, strBaseName, bIsOk )
			Call SqlRetrieve ( hsqlWWW, 'sysadm.GetUsRigth220403', ' :strNameUser ',  ' :strRESOURCE, :strDBA, :strUserAutoriLevel ' )
			Call SqlExecute( hsqlWWW )
			Call SqlGetResultSetCount ( hsqlWWW, nCount )
			If nCount > 0
				Call SqlRetrieve ( hsqlWWW, 'SYSADM.RevGrUs', ' :strNameUser, :strLocAutoriLevel ', '' )
				Call SqlExecute ( hsqlWWW )
		On Procedure Close
			Call SqlDisconnect ( hsqlWWW )
/

CREATE TRIGGER SYSADM.DEL_USLI220401 Before Delete
ON SYSADM.LISTUSER
 ( Execute SYSADM.DelUs220402 ( LISTUSER.Name, LISTUSER.Permit_LEVEL ) )
 For Each Row
/


CREATE TRIGGER SYSADM.INS_CROSS220429 After Insert
ON SYSADM.CrossUsGroup
 ( Execute SYSADM.SetUserTRigth ( CrossUsGroup.IDUSER ) )
For Each Row
/

STORE SYSADM.REVUSERTRIGTH Procedure:  RevUserTRigth static
	Parameters
		String:  strIDUser
		String:  strIDGroup
	Local variables
		Sql Handle: hsqlWWW
		Sql Handle: hsqlW01
		Number: nOk
		Number: numIi
		Number: nCount
		Number: nIsSet
		String: strBaseName
		String: strLocNameUser
		String: strTableName
		Boolean: bIsOk
		String: strPrCName
	Actions
		On Procedure Startup
			Call SqlConnect ( hsqlWWW )
			Call SqlConnect ( hsqlW01 )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( hsqlWWW )
				Set nOk = SqlError ( hsqlW01 )
				Return FALSE
			Set nCount = 0
			Call SqlGetParameterAll ( hsqlWWW, 2001, nOk, strBaseName, bIsOk )
			Call SqlRetrieve ( hsqlWWW, 'SYSADM.GetLiR220506', ' :strBaseName, :strIDUser, :strIDGroup  ', ' :strLocNameUser, :strTableName ' )
			Call SqlExecute( hsqlWWW )
			Call SqlGetResultSetCount ( hsqlWWW, nCount )
			Set numIi = 0
			Set nIsSet  = 0
			If nCount > 0
				Loop
					Call SqlFetchNext  ( hsqlWWW,  nOk )
					If (nOk != FETCH_Ok ) OR (numIi > 1000 )
						Break
					Set numIi = numIi +1
					Call SqlRetrieve ( hsqlW01, 'SYSADM.RevUsTableRigth', ' :strLocNameUser, :strTableName ', '' )
					Call SqlExecute ( hsqlW01 )
		On Procedure Close
			Call SqlDisconnect ( hsqlWWW )
			Call SqlDisconnect ( hsqlW01 )
/

CREATE TRIGGER SYSADM.DEL_CROSS220429 Before Delete
ON SYSADM.CrossUsGroup
 ( Execute SYSADM.RevUserTRigth ( CrossUsGroup.IDUSER, CrossUsGroup.IDGroup ) )
 For Each Row
/


STORE SYSADM.SELGRUS220506 select a.IDUser  
from CrossUsGroup a  
where  
 a.IDGroup = :1
/

STORE SYSADM.INSTABRIG220415 Procedure:  InsTabRig220415 static
	Parameters
		String:  strIDUser
		String:  strIDGroup
	Local variables
		Sql Handle: hsqlWWW
		Sql Handle: hsqlW00
		Number: nOk
		Number: numIi
		Number: nCount
		String: strLocIDUser
		Boolean: bIsOk
	Actions
		On Procedure Startup
			Call SqlConnect ( hsqlWWW )
			Call SqlConnect ( hsqlW00 )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( hsqlWWW )
				Set nOk = SqlError ( hsqlW00 )
				Return FALSE
			If strIDUser != ''
				Call SqlRetrieve ( hsqlWWW, 'SYSADM.SetUserTRigth', ' :strIDUser ', '' )
				Call SqlExecute( hsqlWWW )
			If strIDGroup != ''
				Set nCount = 0
				Call SqlRetrieve ( hsqlWWW, 'SYSADM.SelGrUs220506', ' :strIDGroup ', ' :strLocIDUser ' )
				Call SqlExecute( hsqlWWW )
				Call SqlGetResultSetCount ( hsqlWWW, nCount )
				If ( nCount > 0 )
					Set numIi = 0
					If nCount > 0
						Loop
							Call SqlFetchNext  ( hsqlWWW,  nOk )
							If (nOk != FETCH_Ok ) OR (numIi > 1000 )
								Break
							Set numIi = numIi +1
							Call SqlRetrieve ( hsqlW00,  'SYSADM.SetUserTRigth', ' :strLocIDUser ', '' )
							Call SqlExecute( hsqlW00 )
		On Procedure Close
			Call SqlDisconnect ( hsqlWWW )
			Call SqlDisconnect ( hsqlW00 )
/
CREATE TRIGGER SYSADM.INS_USRIGH220415 After Insert
ON SYSADM.ListRigthUs
 ( Execute SYSADM.InsTabRig220415 ( ListRigthUs.IDUSER, ListRigthUs.IDGROUP ) )
For Each Row
/


CREATE TRIGGER SYSADM.UPD_TABRIG220424 After Update
ON SYSADM.ListRigthUs
( Execute SYSADM.InsTabRig220415 ( ListRigthUs.IDUSER, ListRigthUs.IDGROUP ) )
 For Each Row
/


STORE SYSADM.GETCURRUSTABLE select a.Name, b.TABNAME 
from LISTUSER a, LPATTABLES b, SYSTABAUTH d  
where  
a.ID =   :1  
and b.ID = :2 
and GRANTEE = @upper ( a.Name ) 
and  TTNAME = @upper (  b.TABNAME) 
/

STORE SYSADM.SELGRUSTT220508 select a.Name, b.TABNAME 
from LISTUSER a, LPATTABLES b, SYSTABAUTH d, CrossUsGroup c  
where 
c.IDGroup = :1  
and a.ID =   c.IDUser 
and b.ID = :2 
and GRANTEE = @upper ( a.Name ) 
and  TTNAME = @upper (  b.TABNAME) 
/

STORE SYSADM.RUSTARIG220504 Procedure:  RUsTaRig220504
	Parameters
		String: strUserName
		String: strTabNAme
	Local variables
		String: strCommand
	Actions
		On Procedure Execute
			Set strCommand = '  revoke all on  ' || strTabNAme || ' from ' || strUserName
			Call SqlImmediate ( strCommand )
/


STORE SYSADM.DELTABRIG220415 Procedure:  DelTabRig220415 static
	Parameters
		String:  strIDUser
		String:  strIDGroup
		String:  strIDTable

	Local variables
		Sql Handle: hsqlWWW
		Sql Handle: hsqlW00
		Number: nOk
		Number: numIi
		Number: nCount
		String: strLocNameUser
		String: strLocNameTable
		Boolean: bIsOk

	Actions
		On Procedure Startup
			Call SqlConnect ( hsqlWWW )
			Call SqlConnect ( hsqlW00 )
		On Procedure Execute
			When SqlError
				Set nOk = SqlError ( hsqlWWW )
				Set nOk = SqlError ( hsqlW00 )
				Return FALSE
			If strIDUser != ''
				Call SqlRetrieve ( hsqlWWW, 'SYSADM.GetCurrUsTable', ' :strIDUser, :strIDTable ', ' :strLocNameUser, :strLocNameTable ' )
				Call SqlExecute( hsqlWWW )
			If strIDGroup != ''
				Set nCount = 0
				Call SqlRetrieve ( hsqlWWW, 'SYSADM.SelGrUsTT220508', ' :strIDGroup, :strIDTable ', ' :strLocNameUser, :strLocNameTable ' )
				Call SqlExecute( hsqlWWW )
			Call SqlGetResultSetCount ( hsqlWWW, nCount )
			If ( nCount > 0 )
				Set numIi = 0
				If nCount > 0
					Loop
						Call SqlFetchNext  ( hsqlWWW,  nOk )
						If (nOk != FETCH_Ok ) OR (numIi > 1000 )
							Break
						Set numIi = numIi +1
						Call SqlRetrieve ( hsqlW00,  'SYSADM.RUsTaRig220504', ' :strLocNameUser, :strLocNameTable  ', '' )
						Call SqlExecute( hsqlW00 )

		On Procedure Close
			Call SqlDisconnect ( hsqlWWW )
			Call SqlDisconnect ( hsqlW00 )
/


CREATE TRIGGER SYSADM.DEL_TABRIG220415 Before Delete
ON SYSADM.ListRigthUs
 ( Execute SYSADM.DelTabRig220415 ( ListRigthUs.IDUSER, ListRigthUs.IDGROUP,  ListRigthUs.IDTABLE ) )
 For Each Row
/


